package com.schisandra.oss.application.controller;

import com.alibaba.fastjson.JSON;
import com.google.common.base.Preconditions;
import com.schisandra.oss.application.convert.SchisandraOssQingyunDTOConverter;
import com.schisandra.oss.application.dto.SchisandraOssQingyunDTO;
import com.schisandra.oss.common.entity.Result;
import com.schisandra.oss.domain.bo.SchisandraOssQingyunBO;
import com.schisandra.oss.domain.service.SchisandraOssQingyunDomainService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 青云对象存储配置表 controller
 *
 * @author landaiqing
 * @since 2024-06-02 22:21:09
 */
@RestController
@RequestMapping("/oss/qingyun/")
@Slf4j
public class SchisandraOssQingyunController {

    @Resource
    private SchisandraOssQingyunDomainService schisandraOssQingyunDomainService;

    /**
     * 新增青云对象存储配置表
     */
    @RequestMapping("add")
    public Result<Boolean> add(@RequestBody SchisandraOssQingyunDTO schisandraOssQingyunDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssQingyunController.add.dto:{}", JSON.toJSONString(schisandraOssQingyunDTO));
            }
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getEndpoint(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAccessSecret(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getZone(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCnameSupport(), "是否支持CNAME作为Endpoint，默认不支持CNAME。不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAdditionalUserAgent(), "附加的用户代理不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getVirtualHostEnabled(), "是否启用虚拟Host不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getReadTimeout(), "读超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getWriteTimeout(), "写超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getConnectionTimeout(), "连接超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssQingyunBO SchisandraOssQingyunBO = SchisandraOssQingyunDTOConverter.INSTANCE.convertDTOToBO(schisandraOssQingyunDTO);
            return Result.ok(schisandraOssQingyunDomainService.add(SchisandraOssQingyunBO));
        } catch (Exception e) {
            log.error("SchisandraOssQingyunController.register.error:{}", e.getMessage(), e);
            return Result.fail("新增青云对象存储配置表失败");
        }

    }

    /**
     * 修改青云对象存储配置表
     */
    @RequestMapping("update")
    public Result<Boolean> update(@RequestBody SchisandraOssQingyunDTO schisandraOssQingyunDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssQingyunController.update.dto:{}", JSON.toJSONString(schisandraOssQingyunDTO));
            }
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getEndpoint(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAccessSecret(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getZone(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCnameSupport(), "是否支持CNAME作为Endpoint，默认不支持CNAME。不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAdditionalUserAgent(), "附加的用户代理不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getVirtualHostEnabled(), "是否启用虚拟Host不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getReadTimeout(), "读超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getWriteTimeout(), "写超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getConnectionTimeout(), "连接超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssQingyunBO schisandraOssQingyunBO = SchisandraOssQingyunDTOConverter.INSTANCE.convertDTOToBO(schisandraOssQingyunDTO);
            return Result.ok(schisandraOssQingyunDomainService.update(schisandraOssQingyunBO));
        } catch (Exception e) {
            log.error("SchisandraOssQingyunController.update.error:{}", e.getMessage(), e);
            return Result.fail("更新青云对象存储配置表信息失败");
        }

    }

    /**
     * 删除青云对象存储配置表
     */
    @RequestMapping("delete")
    public Result<Boolean> delete(@RequestBody SchisandraOssQingyunDTO schisandraOssQingyunDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssQingyunController.delete.dto:{}", JSON.toJSONString(schisandraOssQingyunDTO));
            }
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getEndpoint(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAccessSecret(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getZone(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCnameSupport(), "是否支持CNAME作为Endpoint，默认不支持CNAME。不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getAdditionalUserAgent(), "附加的用户代理不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getVirtualHostEnabled(), "是否启用虚拟Host不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getReadTimeout(), "读超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getWriteTimeout(), "写超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getConnectionTimeout(), "连接超时时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssQingyunDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssQingyunBO schisandraOssQingyunBO = SchisandraOssQingyunDTOConverter.INSTANCE.convertDTOToBO(schisandraOssQingyunDTO);
            return Result.ok(schisandraOssQingyunDomainService.delete(schisandraOssQingyunBO));
        } catch (Exception e) {
            log.error("SchisandraOssQingyunController.delete.error:{}", e.getMessage(), e);
            return Result.fail("删除青云对象存储配置表信息失败");
        }

    }

}
